// AirPONG
// SDL air hockey/pong game
// Clarence Pearson

// CParticle class
// NeHe lesson 19 (nehe.gamedev.net)

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "cparticle.h"

// init particle
// takes color (r,g,b)
void CParticle::init(float red, float green, float blue) {
	// set active and lively
	active = 1;
	life = 1.0f;
	fade = 0.055f;
	// set random color
	r = red;
	g = green;
	b = blue;
	// set random x,y speed (no z because this is 2d game)
	v_vel.x = (float)((rand()%35)-18) / 60;
	v_vel.z = (float)((rand()%45)-23) / 60;

	// done
	return;
}

// Update Particle
// depends on coordinate of a CGameOBJ object

void CParticle::update(CGameOBJ *gameobj, float dt) {
	// Add velocity to coordinates
	v_pos.x += v_vel.x * dt;
	v_pos.z += v_vel.z * dt;

	// update z direction
	if(gameobj->v_vel.z < 0) {
		if(v_vel.z < 0) { v_vel.z = -v_vel.z; }
	}

	if(gameobj->v_vel.z > 0) {
		if(v_vel.z > 0) { v_vel.z = -v_vel.z; }
	}

	// reduce life by fade
	life -= fade;
	// check to see if particle is "dead"
	if(life < 0.0f) {
		// set coordinates to game object
		v_pos.x = gameobj->v_pos.x;
		v_pos.z = gameobj->v_pos.z;
		// give new life and new fade value
		life = 1.0f;
		fade = (float)((rand()%15) + 5) * dt;
	}

	// good to go
	return;
}

// draw
// draws using OpenGL primitives to draw triangle strip
void CParticle::draw() {
	// set drawing color
	glColor4f(r, g, b, life);
	// draw triangle strip
	glBegin(GL_TRIANGLE_STRIP);
		glVertex3f(v_pos.x, 0, v_pos.z);
		glVertex3f(v_pos.x, 0, v_pos.z + 0.015);
		glVertex3f(v_pos.x + 0.015, 0, v_pos.z + 0.015);
		glVertex3f(v_pos.x + 0.015, 0, v_pos.z);
	glEnd();
}
