// AirPong
// Clarence Pearson

// define game's scene class

#ifndef __SCENE_H_
#define __SCENE_H_

// include LeadPipe headers
#include "cscene.h"
#include "cfont.h"
#include "cengine.h"
#include "cmenu.h"
#include "cparticle.h"
// game objects header
#include "objects.h"

// game varibles class
class CGameVars {
	public:
		// contructor
		CGameVars() {
			player_score = 0;
			computer_score = 0;
			game_over = false;
		}
		~CGameVars() {}
		// reset game vars
		void Reset() {
			player_score = 0;
			computer_score = 0;
			game_over = false;
		}
		// scores
		int player_score;
		int computer_score;
		// game over flag
		bool game_over;
};

// CGame class derived from CScene Class
class CGame : public CScene {
	public:
		// constructor
		CGame(CEngine *);
		// destructor
		~CGame();
		// update scene
		virtual void Update();
		// Render Scene
		virtual void Render();
		// ball object
		CBall *ball;
		// player bat
		CPlayer *pbat;
		// computer bat
		CComputer *cbat;
		// game vars object
		CGameVars *game_vars;
		// menu
		CMenu *menu;
	private:
		// font object
		CFont *font;
		// particles
		CParticle *particles;
		// coordinates for arena
		float arena[4];
};

#endif
