// Clarence Pearson
// LeadPipe OpenGL Engine

// CEngine Class
// Wraps window, input, and objects together
// This is a base class that is based on COGLwin

#ifndef __CENGINE_H_
#define __CENGINE_H_

#include "SDL.h"
#include "coglwin.h"

class CEngine : public COGLWin {
    public:
        // constructor
        // just calls parent constructor
        CEngine(char *,int,int,int,int);
        // destructor
        ~CEngine() {}
        // run engine based on scene passed to it
        virtual void RunCycle();
		// render scene
		virtual void RenderScene() {}
        // event handler
        virtual void HandleEvent();
        // keyboard handler
        virtual void HandleKeyboard(SDL_Event *);
        // mouse movement handler
        virtual void HandleMouseMovement(SDL_Event *);
        // mouse button handler
        virtual void HandleMouseButton(SDL_Event *);
    protected:
        // engine run flag
        // destroy engine when = 0
        int engine_run;
};

#endif
