// Clarence Pearson
// LeadPipe OpenGL Engine

// CLPMap Map Classes
// 2d and 3d map classes

#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <stdlib.h>
#include "clpmap.h"

// read a string from a file
void read_string(FILE *f, char *string) {
	do {
		// read one line
		fgets(string, 255, f);
	} while((string[0] == '#') || (string[0] == '\r') || (string[0] == '\n') || (string[0] == '\0'));
	// ignore blank lines or commented lines

	return;
}

// load map
void CLPMap::Load(char *fn) {
	// file
	FILE *file;

	// line of text
	char t_line[255];

	// number of quads
	int num_quads;

	num_sectors = 1;

	// number of sectors
	//num_sectors = 1;

	// open file
	file = fopen(fn, "rt");

	// read number of sectors
	//read_string(file, t_line);
	//sscanf(t_live, "SECTORS = %d\n", &num_sectors);

	// read number of quads
	read_string(file, t_line);

	// read in number of quads
	sscanf(t_line, "QUADS = %d\n", &num_quads);

	// allocate space for sectors and quads
	sector = new SECTOR[num_sectors];
	sector[0].quad = new QUAD[num_quads];
	sector[0].num_quads = num_quads;

	// loop through all sectors
	for(int s_loop = 0; s_loop < num_sectors; s_loop++) {
		// get coordinates for quads
		// loop through quads and read vertices
		for(int q_loop = 0; q_loop < num_quads; q_loop++) {
			float r, g, b, a;
			// read color
			read_string(file, t_line);
			sscanf(t_line, "%f %f %f %f\n", &r, &g, &b, &a);
			sector[s_loop].quad[q_loop].color[0] = r;
			sector[s_loop].quad[q_loop].color[1] = g;
			sector[s_loop].quad[q_loop].color[2] = b;
			sector[s_loop].quad[q_loop].color[3] = a;
			// loop through vertices
			for(int v_loop = 0; v_loop < 4; v_loop++) {
				float x, y, z;
				// read line of text
				read_string(file, t_line);
				// get vertices
				sscanf(t_line, "%f %f %f\n", &x, &y, &z);
				sector[s_loop].quad[q_loop].vertex[v_loop].pos.x = x;
				sector[s_loop].quad[q_loop].vertex[v_loop].pos.y = y;
				sector[s_loop].quad[q_loop].vertex[v_loop].pos.z = z;
			}
		}
	}

	//printf("map loaded\n");

	//printf("%f %f %f\n",sector.quad[0].vertex[0].x,sector.quad[0].vertex[0].y,sector.quad[0].vertex[0].z);

	// close file
	fclose(file);

	return;
}

// draw map
void CLPMap::Draw() {
	float x, y, z;
	
	// turn blending off
	glDisable(GL_BLEND);

	// loop through each quad
	for(int loop = 0; loop < sector[0].num_quads; loop++) {
		// start drawing quad
		// set color
		glColor4fv(sector[0].quad[loop].color);
		glBegin(GL_QUADS);
			// get and draw vertices
			x = sector[0].quad[loop].vertex[0].pos.x;
			y = sector[0].quad[loop].vertex[0].pos.y;
			z = sector[0].quad[loop].vertex[0].pos.z;
			glVertex3f(x, y, z);

			// vertex 2
			x = sector[0].quad[loop].vertex[1].pos.x;
			y = sector[0].quad[loop].vertex[1].pos.y;
			z = sector[0].quad[loop].vertex[1].pos.z;
			glVertex3f(x, y, z);

			// vertex 3
			x = sector[0].quad[loop].vertex[2].pos.x;
			y = sector[0].quad[loop].vertex[2].pos.y;
			z = sector[0].quad[loop].vertex[2].pos.z;
			glVertex3f(x, y, z);

			// vertex 4
			x = sector[0].quad[loop].vertex[3].pos.x;
			y = sector[0].quad[loop].vertex[3].pos.y;
			z = sector[0].quad[loop].vertex[3].pos.z;
			glVertex3f(x, y, z);
		glEnd();
	}

	glEnable(GL_BLEND);

}
