// Clarence Pearson
// LeadPipe OpenGL Engine

// CLPMap Map Classes
// 2d and 3d map classes

#ifndef __CLPMAP_H_
#define __CLPMAP_H_

#include "cvector.h"

// define vertex struct
typedef struct {
	// position is stored as a vector
	// this is useful for determining the normal of a polygon
	CVector3 pos;
	// texture coordinates
	float u, v;
} VERTEX;

// define quad struct
// note--this will be extended to any polygon
typedef struct {
	// four vertices
	VERTEX vertex[4];
	// color
	float color[4];
} QUAD;

// define sector struct
typedef struct {
	// number of quads
	int num_quads;
	// quad array
	QUAD *quad;
} SECTOR;

// 2d map class
class CLPMap {
	public:
		// constructor
		// pass file name
		CLPMap(char *name) {
			Load(name);
		}
		CLPMap() {}
		// destructor
		~CLPMap() {
			// free sectors
			delete[] sector;
		}
		// load map
		void Load(char *);
		// draw map
		void Draw();
	protected:
		// current sector
		int current_sector;
		// number of sectors
		int num_sectors;
		// sectors array
		SECTOR *sector;
};

#endif
