// Clarence Pearson
// LeadPipe OpenGL Engine

// COGLWin Class
// Creates an OpenGL window using SDL
// Initializes OpenGL

#ifndef __COGLWIN_H_
#define __COGLWIN_H_

// include OpenGL and SDL

#include <GL/gl.h>
#include <GL/glu.h>
#include "SDL.h"

class COGLWin {
    public:
        // constructor
        // builds window name, width, height, bpp, fullscreen flag
        COGLWin(char *, int, int, int, int);
        // destructor
        ~COGLWin();
        // initialize OpenGL
        virtual void InitOGL();
        // handle resizing of window
        void ResizeWindow(int, int);
        // Clear Window
        void ClearWin();
        // Draw Window
        virtual void DrawWin();
		// screen defs
        int screen_h, screen_w;
		int bpp;
    protected:
        // SDL surface
        SDL_Surface *screen;
        // video flags for window
        int v_flags;
};

#endif

