// Clarence Pearson
// LeadPipe OpenGL Engine

// CRAW class
// loads RAW file and display

#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "cvector.h"
#include "craw.h"

// load RAW file
void CRAW::Load(char *fn) {
	num_vertices = 0;
	// temporary vector
	CVector3 tmp;

	// file obeject
	ifstream file(fn);

	// loop until file has ended
	// increase number of vertices
	while(!file.eof()) {
		file >> tmp.x;
		file >> tmp.y;
		file >> tmp.z;
		
		num_vertices++;
	}

	// allocate space for vertices
	vertex = new CVector3[num_vertices];

	// close file
	file.close();

	// reopen file
	ifstream file2("data/model.raw");

	// load vertices
	for(int i=0;i < num_vertices;i++) {
		file2 >> vertex[i].x;
		file2 >> vertex[i].y;
		file2 >> vertex[i].z;
	}

	// close file
	file2.close();

	return;
}

// draw RAW image
void CRAW::Draw() {
	// begin triangles
	glBegin(GL_TRIANGLES);
		// loop through all the vertices
		for(int i=0; i < num_vertices; i += 3) {
			glVertex3f(vertex[i].x, vertex[i].y, vertex[i].z);
			glVertex3f(vertex[i+1].x, vertex[i+1].y, vertex[i+1].z);
			glVertex3f(vertex[i+2].x, vertex[i+2].y, vertex[i+2].z);
		}
	glEnd();
	return;
}
