// Clarence Pearson
// LeadPipe OpenGL Engine

// CScene Class
// Draws Scene and Objects

#include <GL/gl.h>
#include <GL/glu.h>
#include "cscene.h"
#include "ctimer.h"

// constructor
CScene::CScene(CEngine *window) {
	// set width and height
	width = window->screen_w;
	height = window->screen_h;
	// new timer
	timer = new CTimer;
}

// set ortho projection
void CScene::SetOrtho() {
	// push and reset projection matrix
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0, width, height, 0, -1, 1);
	
	// reset and push modelview matrix
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	
	return;
}

// unset ortho projection
void CScene::UnSetOrtho() {
	// reset matrices
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	
	return;
}
