// Clarence Pearson
// LeadPipe OpenGL Engine

// CScene Class
// Draws Scene and Objects

#ifndef __CSCENE_H_
#define __CSCENE_H_

#include "cengine.h"
#include "ctimer.h"

// this is a base class

class CScene {
    public:
        // constructor, takes CEngine as object
        // this should initialize all objects
        CScene(CEngine *);
        // destructor should delete all objects
        ~CScene() {};
        // update scene
        virtual void Update() {};
        // render scene
        virtual void Render() {};
		// set ortho projection
		void SetOrtho();
		void UnSetOrtho();
		// all scene objects have timer
		CTimer *timer;
	protected:
		// width and height for ortho
		int width, height;
		// objects go here
};

#endif
