// Clarence Pearson
// LeadPipe OpenGL Engine

// CTexture Class

// handles loading and generating textures
// note - only BMP supported right now

#include <GL/gl.h>
#include <GL/glu.h>
// include SDL and SDL_image
#include "SDL.h"
//#include "SDL_image.h"
#include "ctexture.h"

// constructor
CTexture::CTexture(char *fn, int flag) {
	// load texture
	Load(fn, flag);
}

// load texture
int CTexture::Load(char *fn, int flag) {
	// sdl surface
	SDL_Surface *image;
	
	// load image
	if((image = SDL_LoadBMP(fn))) {
		// create texture
		glGenTextures(1, &tex_id);
		glBindTexture(GL_TEXTURE_2D, tex_id);
		// generate texture
		glTexImage2D(GL_TEXTURE_2D, 0, 3, image->w, image->h, 0, GL_RGB, GL_UNSIGNED_BYTE, image->pixels);
		// linear filtering
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	} else {
		// error
		return -1;
	}
	
	// free image
	SDL_FreeSurface(image);
	
	// good to go
	return 1;
}

// bind texture
void CTexture::Bind() {
	glBindTexture(GL_TEXTURE_2D, tex_id);
	return;
}
