// Clarence Pearson
// LeadPipe OpenGL Engine

// CTexture Class

// handles loading and generating textures
// note - only BMP supported right now

#ifndef __CTEXTURE_H_
#define __CTEXTURE_H_

#include <GL/gl.h>
#include <GL/glu.h>

// define image type flags
#define BMP 0
#define TGA 1
#define PNG 2
#define PCX 3
#define JPG 4
#define GIF 5

class CTexture {
	public:
		// constructor
		CTexture() {};
		CTexture(char *,int);
		// destructor
		~CTexture() {};
		// load texture - returns negative on failure
		// (filename, image type)
		int Load(char *, int);
		// bind texture
		void Bind();
		// texture id
		GLuint tex_id;
		// height and width
		int h, w;
		// bits per pixel
		int bpp;
};

#endif
