// Clarence Pearson
// LeadPipe OpenGL Engine

// CTimer Class
// gets fps
// delta_time used for all movements in engine

#include "SDL.h"
#include "ctimer.h"

// constructor
// set starting time
CTimer::CTimer() {
	time_start = SDL_GetTicks();
}

// update
void CTimer::Update() {
	float new_time;

	// get current time
	time = SDL_GetTicks();
	
	new_time = time * 0.001f;

	// get delta time
	dt = (new_time - time_last);
	time_last = new_time;

	// increment frames counter
	frames++;

	// calculate fps
	fps = (int)(1000 * frames / time);

	return;
}

// limit FPS
void CTimer::Limit(float limit) {
	float new_fps = 1000 / limit;
	float frame_time = time_last * 1000;
	float time_taken = time - frame_time;

	// check to see if fps is > than desired
	if(time_taken < new_fps) {
		// delay spme
		SDL_Delay((int)(new_fps - time_taken));
	}
}

