// Clarence Pearson
// LeadPipe OpenGL Engine

// CVector Class
// basic vector class...nothing fancy or special

#include <math.h>
#include "cvector.h"

// calculate cross product between two vectors
CVector3 Cross(CVector3 v1, CVector3 v2) {
	CVector3 v_normal;

	v_normal.x = ((v1.y * v2.z) - (v1.z * v2.y));
	v_normal.y = ((v1.z * v2.x) - (v1.x * v2.z));
	v_normal.z = ((v1.x * v2.y) - (v1.y * v2.x));

	// return cross product
	return v_normal;
}

// calculate the magnitude of a vector
float Magnitude(CVector3 vector) {
	return((float)sqrt((vector.x * vector.x) + (vector.y * vector.y) + (vector.z * vector.z)));
}

// normalize a vector
CVector3 Normalize(CVector3 vector) {
	// get magnitude
	float mag = Magnitude(vector);
	
	// divide vector by magnitude
	vector = vector / mag;

	// return normal vector
	return vector;
}

// return dot product
float Dot(CVector3 v1, CVector3 v2) {
	return (v1.x*v2.x)+(v1.y*v2.y)+(v1.z*v2.z);
}

// return vector between two points
CVector3 Vector(CVector3 v1, CVector3 v2) {
	// subtract second point from first point
	return(v1 - v2);
}
