// Clarence Pearson
// LeadPipe OpenGL Engine

// CVector Class
// basic vector class...nothing fancy or special

#ifndef __CVECTOR_H_
#define __CVECTOR_H_

#include <math.h>

// CVector class
class CVector3 {
    public:
        // x, y, z coordinates
        float x, y, z;
		// default constructor
		CVector3() {};
		// constructor with args
		CVector3(float X, float Y, float Z) {
			x = X; y = Y; z = Z;
		}
		// overload basic operators
		CVector3 operator+(CVector3 vVector) {
			return CVector3(vVector.x + x, vVector.y + y, vVector.z + z);
		}
		CVector3 operator-(CVector3 vVector) {
			return CVector3(x - vVector.x, y - vVector.y, z - vVector.z);
		}
		CVector3 operator*(float num) {
			return CVector3(x * num, y * num, z * num);
		}
		CVector3 operator/(float num) {
			return CVector3(x / num, y / num, z / num);
		}
};

// calculate cross product between two vectors
CVector3 Cross(CVector3, CVector3);
// calculate the magnitude of a vector
float Magnitude(CVector3);
// normalize a vector
CVector3 Normalize(CVector3);
// return dot product
float Dot(CVector3, CVector3);
// return vector between two points
CVector3 Vector(CVector3, CVector3);

#endif
