// AirPong
// Clarence Pearson

// define classes for AirPong objects

#ifndef __OBJECTS_H_
#define __OBJECTS_H_

#include <GL/gl.h>
#include <GL/glu.h>
// leadpipe headers
#include "cobject.h"
#include "cvector.h"

// game object class
class CGameOBJ : public CObject {
	public:
		float w, h;
};

// define ball class
class CBall : public CGameOBJ {
	public:
		// constructor
		CBall();
		~CBall() {}
		// update
		// passes delta time and arena coords
		void Update(float, float, float);
		// reset object
		void Reset();
		// draw
		virtual void Draw();
		//  quadratic
		GLUquadricObj *quadratic;
};

// define player bat class
class CPlayer : public CGameOBJ {
	 public:
	 	// constructor
		CPlayer();
		~CPlayer() {}
		// move based on delta time
		// passes arena coords
		void MoveL(float, float);
		void MoveR(float, float);
		// update
		void Update(float, float, float);
		// reset object
		void Reset();
		// draw
		virtual void Draw();
};

// define computer bat class
class CComputer : public CGameOBJ {
	 public:
		// constructor
		CComputer();
		~CComputer() {}
		// update based on delta time, arena coors, and ball
		void Update(float, float, float, CBall *);
		// reset object
		void Reset();
		// draw
		virtual void Draw();
};

// check for collsion between objects
bool Collision(CGameOBJ *, CGameOBJ *);

#endif
